'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Yusuke Nunokawa (https://ynunokawa.github.io)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var Geocoder = function (_React$Component) {
  _inherits(Geocoder, _React$Component);

  function Geocoder(props) {
    _classCallCheck(this, Geocoder);

    var _this = _possibleConstructorReturn(this, (Geocoder.__proto__ || Object.getPrototypeOf(Geocoder)).call(this, props));

    _this.state = {
      text: '',
      suggestions: []
    };
    _this._onSearch = _this._onSearch.bind(_this);
    _this._onChangeText = _this._onChangeText.bind(_this);
    _this._onClickSuggestion = _this._onClickSuggestion.bind(_this);
    _this._onKeyPress = _this._onKeyPress.bind(_this);
    return _this;
  }

  _createClass(Geocoder, [{
    key: '_onSearch',
    value: function _onSearch(e) {
      this.search(this.state.text);
    }
  }, {
    key: '_onChangeText',
    value: function _onChangeText(e) {
      this.setState({ text: e.target.value });
      if (this.state.text.length > 2) {
        L.esri.Geocoding.suggest().text(this.state.text).run(function (err, response) {
          console.log(err, response.suggestions);
          this.setState({ suggestions: response.suggestions });
        }.bind(this));
      } else {
        this.setState({ suggestions: [] });
      }
    }
  }, {
    key: '_onClickSuggestion',
    value: function _onClickSuggestion(e) {
      this.search(e.target.textContent);
    }
  }, {
    key: '_onKeyPress',
    value: function _onKeyPress(e) {
      if (e.charCode === 13) {
        this.search(this.state.text);
      }
    }
  }, {
    key: 'search',
    value: function search(text) {
      L.esri.Geocoding.geocode().text(text).run(function (err, results, response) {
        this.setState({ suggestions: [] });
        this.props.onSearch(results.results[0].bounds);
      }.bind(this));
    }
  }, {
    key: 'render',
    value: function render() {
      var suggestions = null;

      if (this.state.suggestions.length > 0) {
        var suggestionItems = this.state.suggestions.map(function (s, i) {
          return _react2.default.createElement(
            _reactBootstrap.MenuItem,
            { onClick: this._onClickSuggestion, key: s.magicKey },
            s.text
          );
        }.bind(this));
        suggestions = _react2.default.createElement(
          _reactBootstrap.Dropdown.Menu,
          null,
          suggestionItems
        );
      } else {
        suggestions = _react2.default.createElement('span', null);
      }

      return _react2.default.createElement(
        _reactBootstrap.FormGroup,
        null,
        _react2.default.createElement(
          _reactBootstrap.InputGroup,
          { onChange: this._onChangeText },
          _react2.default.createElement(_reactBootstrap.FormControl, { type: 'text', placeholder: this.props.placeholder, onKeyPress: this._onKeyPress }),
          _react2.default.createElement(
            _reactBootstrap.InputGroup.Button,
            null,
            _react2.default.createElement(
              _reactBootstrap.Button,
              { onClick: this._onSearch },
              _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'search' })
            )
          )
        ),
        _react2.default.createElement(
          'style',
          { type: 'text/css' },
          '\n        .dropdown-menu {\n            display: block;\n            top: 85%;\n            left: 15px;\n        }\n        '
        ),
        suggestions
      );
    }
  }]);

  return Geocoder;
}(_react2.default.Component);

Geocoder.propTypes = {
  placeholder: _react2.default.PropTypes.string,
  onSearch: _react2.default.PropTypes.func
};

Geocoder.defaultProps = {
  placeholder: 'Search for places or addresses',
  onSearch: function onSearch() {}
};

Geocoder.displayName = 'Geocoder';

exports.default = Geocoder;