'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Yusuke Nunokawa (https://ynunokawa.github.io)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var ListGroupItems = function (_React$Component) {
  _inherits(ListGroupItems, _React$Component);

  function ListGroupItems(props) {
    _classCallCheck(this, ListGroupItems);

    var _this = _possibleConstructorReturn(this, (ListGroupItems.__proto__ || Object.getPrototypeOf(ListGroupItems)).call(this, props));

    _this._onClickList = _this._onClickList.bind(_this);
    return _this;
  }

  _createClass(ListGroupItems, [{
    key: '_onClickList',
    value: function _onClickList(e) {
      var layoutFields = this.props.layoutFields;
      var layer = this.props.layer;
      if (layer !== null) {
        layer.eachFeature(function (l) {
          if (e.target.title === l.feature.properties[layoutFields.name]) {
            this.props.onClickList(l.feature.geometry.coordinates.reverse(), 17);
          }
        }.bind(this));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      _reactBootstrap.utils.bootstrapUtils.addStyle(_reactBootstrap.ListGroupItem, 'custom');
      _reactBootstrap.utils.bootstrapUtils.addStyle(_reactBootstrap.Badge, 'custom');

      var layoutFields = this.props.layoutFields;
      var typeValue = this.props.typeValue;

      var listGroupHeader = _react2.default.createElement(
        _reactBootstrap.ListGroupItem,
        { bsStyle: 'custom' },
        typeValue
      );

      var listGroupItems = this.props.features.map(function (f, index) {
        return _react2.default.createElement(
          _reactBootstrap.ListGroupItem,
          { title: f.properties[layoutFields.name], onClick: this._onClickList, href: '#', key: f.properties[layoutFields.name] + "-" + index },
          f.properties[layoutFields.name],
          _react2.default.createElement(
            _reactBootstrap.Badge,
            null,
            f.properties[layoutFields.label]
          )
        );
      }.bind(this));

      return _react2.default.createElement(
        _reactBootstrap.ListGroup,
        null,
        listGroupHeader,
        listGroupItems
      );
    }
  }]);

  return ListGroupItems;
}(_react2.default.Component);

ListGroupItems.propTypes = {
  typeValue: _react2.default.PropTypes.string,
  features: _react2.default.PropTypes.array,
  layer: _react2.default.PropTypes.object,
  layoutFields: _react2.default.PropTypes.object,
  onClickList: _react2.default.PropTypes.func
};

ListGroupItems.defaultProps = {
  onClickList: function onClickList() {}
};

ListGroupItems.displayName = 'ListGroupItems';

exports.default = ListGroupItems;