'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapSwitch = require('react-bootstrap-switch');

var _reactBootstrapSwitch2 = _interopRequireDefault(_reactBootstrapSwitch);

var _ListGroupItems = require('./ListGroupItems');

var _ListGroupItems2 = _interopRequireDefault(_ListGroupItems);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Yusuke Nunokawa (https://ynunokawa.github.io)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var ListGroups = function (_React$Component) {
  _inherits(ListGroups, _React$Component);

  function ListGroups(props) {
    _classCallCheck(this, ListGroups);

    var _this = _possibleConstructorReturn(this, (ListGroups.__proto__ || Object.getPrototypeOf(ListGroups)).call(this, props));

    _this.state = {
      filter: _this.props.filter
    };
    _this._onClickList = _this._onClickList.bind(_this);
    _this.onFilter = _this.onFilter.bind(_this);
    return _this;
  }

  _createClass(ListGroups, [{
    key: '_onClickList',
    value: function _onClickList(e) {
      console.log(e.target.title);
      var layoutFields = this.props.layoutFields;
      var layer = this.props.layer;
      var lyr = null;
      Object.keys(layer.layer._layers).map(function (k) {
        if (layer.layer._layers[k]._cache !== undefined) {
          lyr = layer.layer._layers[k];
        }
      });
      if (lyr !== null) {
        lyr.eachFeature(function (l) {
          if (e.target.title === l.feature.properties[layoutFields.name]) {
            console.log(l);
            this.props.onClickList(l.feature.geometry.coordinates.reverse(), 17);
          }
        }.bind(this));
      }
    }
  }, {
    key: 'onFilter',
    value: function onFilter(elm, state) {
      console.log(state);
      this.setState({ filter: state });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.render();
    }
  }, {
    key: 'render',
    value: function render() {
      var layer = this.props.layer;
      var layoutFields = this.props.layoutFields;
      var bounds = this.props.mapState.bounds;
      var filter = this.state.filter;

      var filterSwitch = void 0;

      if (this.props.switch === true) {
        filterSwitch = _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 12 },
          _react2.default.createElement(
            'style',
            { type: 'text/css' },
            '\n        .bootstrap-switch {\n            margin-top: 10px;\n            margin-bottom: 10px;\n        }\n        '
          ),
          _react2.default.createElement(_reactBootstrapSwitch2.default, {
            defaultValue: this.props.filter,
            onChange: this.onFilter,
            onText: "Filtered",
            offText: "Unfiltered"
          })
        );
      }

      var listGroups = layoutFields.typeValues.map(function (t, i) {
        var features = [];
        var lyr = null;

        Object.keys(layer.layer._layers).map(function (k) {
          if (layer.layer._layers[k]._cache !== undefined) {
            lyr = layer.layer._layers[k];
          }
        });
        if (lyr !== null) {
          lyr.eachFeature(function (l) {
            if (l.feature.properties[layoutFields.type] === t) {
              if (filter) {
                if (bounds.contains(l._latlng)) {
                  features.push(l.feature);
                }
              } else {
                features.push(l.feature);
              }
            }
          });
        }
        features = features.sort(function (a, b) {
          return b.properties[layoutFields.sort] - a.properties[layoutFields.sort];
        });

        return _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 12, sm: 6, md: 4, key: t },
          _react2.default.createElement(_ListGroupItems2.default, {
            typeValue: t,
            features: features,
            layer: lyr,
            layoutFields: this.props.layoutFields,
            onClickList: this.props.onClickList
          })
        );
      }.bind(this));

      return _react2.default.createElement(
        _reactBootstrap.Grid,
        null,
        _react2.default.createElement(
          _reactBootstrap.Row,
          null,
          filterSwitch,
          _react2.default.createElement(
            'style',
            { type: 'text/css' },
            '\n            .list-group-item-custom {\n                background-color: #f5646a;\n                color: #fff !important;\n                border-color: #f5646a;\n                font-weight: bold;\n            }\n            .list-group-item-custom:hover {\n                background-color: #f5646a !important;\n                opacity: 0.8;\n            }\n            .list-group-item {\n                font-size: 0.9em;\n            }\n            .badge {\n                background-color: #f5646a;\n                color: #fff;\n            }\n            '
          ),
          listGroups
        )
      );
    }
  }]);

  return ListGroups;
}(_react2.default.Component);

ListGroups.propTypes = {
  layer: _react2.default.PropTypes.object,
  layoutFields: _react2.default.PropTypes.object,
  mapState: _react2.default.PropTypes.object,
  filter: _react2.default.PropTypes.bool,
  switch: _react2.default.PropTypes.bool,
  onClickList: _react2.default.PropTypes.func
};

ListGroups.defaultProps = {
  switch: true,
  onClickList: function onClickList() {}
};

ListGroups.displayName = 'ListGroups';

exports.default = ListGroups;